#!/usr/bin/env python
#
# Copyright 2010 Canonical, Ltd
# Author: Brian Murray <brian@ubuntu.com>
# License: GPLv3
# 
# 2010-04-29 
# Find out information about when a why a package was removed from that archive

from launchpadlib.errors import HTTPError

import sys

import lpl_common

launchpad = lpl_common.connect(use_edge=False)

ubuntu = launchpad.distributions['ubuntu']

primary = launchpad.load(str(launchpad._root_uri) + 'ubuntu/+archive/primary')

target = sys.argv[1]

for published_source in primary.getPublishedSources(status="Deleted",
    source_name=target, exact_match=True):
    if published_source.pocket == 'Release':
        try:
            package_name = published_source.source_package_name
            removed_from = published_source.distro_series.name
            pocket = published_source.pocket
            # date_removed seems to be None for most packages so use
            # date_superseded which seems good
            date_removed = published_source.date_superseded.date()
            reason = published_source.removal_comment.strip("\n")
            print "%s was removed from %s on %s because %s" % \
                (package_name, removed_from.title(), date_removed, reason)
        except HTTPError, error:
            print "There was an error with package %s: %s" % \
                (published_source.source_package_name, error)
