#!/usr/bin/python
# This script creates the data to be used for reporting on
# the automated upgrades test results.
# It is based on the ubuntu weatherreport from Leann Ogasawara.
#
# Copyright 2010  Canonical, Ltd.
# Author: Marjo Mercado <marjo.mercado@canonical.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
# the full text of the license.

from qadashboard_utils import *
import urllib
import re

def automatic_upgrades():
    metric = "Automatic Upgrade Test Results"
    url = "http://people.canonical.com/~mvo/automatic-upgrade-testing/current/"
    failed_upgrades = parse_entire_url(url, '</td><td class="error"')
    if len(failed_upgrades) > 0:
        color = ""
    else:
        color = GREEN

    status = "Failed"
    count = 0
    for i in failed_upgrades:
        if "edgy" in i:
            continue
        status += i + " "
        count += 1
    status = str(count) + " " + status

    data = "automatic_upgrades: metric=\"%s\" color=\"%s\" url=\"%s\" status=\"%s\"" % (metric, color, url, status)
    create_file(AUTOMATIC_UPGRADES_FILE, data)

    item = [{'metric': metric,
             'color': color,
             'url': url,
             'status': status}]
    return item

automatic_upgrades()
