#!/usr/bin/python
# This script creates the data to be used for reporting on
# boot metrics regression.
# It is based on the ubuntu weatherreport from Leann Ogasawara.
#
# Copyright 2010  Canonical, Ltd.
# Author: Marjo Mercado <marjo.mercado@canonical.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
# the full text of the license.

from qadashboard_utils import *


def boot_regressions():
    metric = "Boot Speed Regression Results"
    url = "http://people.canonical.com/~brian/daily-bootcharts/index.html"

    # A red cell indicates that there is a regression and we only care about
    # cells with an id of release_diff (Natty vs Maverick) at the moment
    boot_regressions = parse_entire_url(url, 'BGCOLOR="red".*release_diff')
    if len(boot_regressions) > 0:
        color = RED
    else:
        color = GREEN

    status = "Regression"
    count = 0

    for i in boot_regressions:
#        status += i + " "
        count += 1
    status = "%s %s" % (count, status)
    if count != 1:
        status += "s"

    data = 'boot_regressions: metric="%s" color="%s" url="%s" status="%s"' % \
            (metric, color, url, status)
    create_file(BOOT_REGRESSIONS_FILE, data)

    item = [{'metric': metric,
            'color': color,
            'url': url,
            'status': status}]
    return item

boot_regressions()
