#!/usr/bin/python
# This script creates the data to be used for reporting on
# the automated Desktop and Alternate image tests.
# It is based on the ubuntu weatherreport from Leann Ogasawara.
#
# Copyright 2011  Canonical, Ltd.
# Author: Marjo Mercado <marjo.mercado@canonical.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
# the full text of the license.

from qadashboard_utils import *
import subprocess
import re


def desktop_tests():
    # Setup for writing to the data file
    metric = "Desktop and Alternate Images Automated Tests Results"
    data = ""
    status = "Testing In Progress"
    url = "http://204.236.234.12:8080/view/natty-desktop"
    prc = subprocess.Popen(['wget', '--output-document=-', url],
            stdout=subprocess.PIPE,
            stderr=subprocess.PIPE)
    (stdout, stderr) = prc.communicate()
    failures = 0
    pattern = re.compile('tooltip="Failed"')
    for line in stdout.splitlines():
        if pattern.search(line):
            failures += 1
    if failures == 0:
        color = GREEN
        status = "No failures"
    else:
        color = RED
        status = "%d failure%s" % (failures, '' if failures == 1 else 's')


    # Note: The name of the metric must not contain spaces
    data = "desktop_automated_tests: metric=\"%s\" color=\"%s\" url=\"%s\" status=\"%s\"" % (metric, color, url, status)
    create_file(DESKTOP_TESTS_FILE, data)

desktop_tests()
