#!/usr/bin/python
# This script creates the data to be used for reporting on
# the ISO image testing results.
# It is based on the ubuntu weatherreport from Leann Ogasawara.
#
# Copyright 2010  Canonical, Ltd.
# Author: Marjo Mercado <marjo.mercado@canonical.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
# the full text of the license.

from qadashboard_utils import *

def iso_testing():
    url = "http://iso.qa.ubuntu.com/qatracker/build/all/all"
    metric = parse_url(url, "<h2>(.*?)<")
    color = ""
    status = ""
    if metric == None:
        metric = ""
    metric = "ISO Testing " + metric
    iso_testing = parse_url(url, "We are (not testing at the moment)")
    if iso_testing != None:
        color = GREY
        status = iso_testing
    else:
        iso_testing = parse_entire_url(url, "<span.*?>(\d+)/(\d+)</span>")
        iso_testing += parse_entire_url(url, "<td style=\"width:\d+%\" align=\"left\" valign=\"bottom\">(\d+)/(\d+)")

        for iso in iso_testing:
            color = GREEN
            status = "Testing Complete"
            if iso[0] != iso[1]:
                color = ""
                status = "Testing Incomplete"
                break

    data = "iso_testing: metric=\"%s\" color=\"%s\" url=\"%s\" status=\"%s\"" % (metric, color, url, status)
    create_file(ISO_TESTING_FILE, data)

iso_testing()
