#!/usr/bin/python
# This script creates the web page for the QA Dashboard
# It is based on the ubuntu weatherreport from Leann Ogasawara.
#
# Copyright 2010  Canonical, Ltd.
# Author: Marjo Mercado <marjo.mercado@canonical.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
# the full text of the license.

from qadashboard_utils import *
from datetime import datetime

html = "<html>\n"
html += "<head>\n"
html += "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"60;\">\n"
html += "<link defanghtml_rel=\"made\" defanghtml_href=\"mailto:webmaster@ubuntu.com\">"
html += "<link rel=\"stylesheet\" type=\"text/css\" charset=\"utf-8\" media=\"all\" href=\"http://www.ubuntu.com/htdocs/ubuntuweb/css/common.css\">\n"
html += "<link rel=\"stylesheet\" type=\"text/css\" charset=\"utf-8\" media=\"screen\" href=\"http://www.ubuntu.com/htdocs/ubuntuweb/css/screen.css\">\n"
html += "<h2>%s</h2>\n" % (RELEASE_LONGNAME)
html += "</head>\n"
html += "<body>\n"
html += "<p>\n"
html += "<table border=\"5\">\n"
html += "<tbody><tr>\n"
html += "    <td><b>Metric</b></td>\n"
html += "    <td align=\"center\"><b>Status</b></td>\n"
html += "</tr>\n"
file = DATA_DIR + "complete_data.txt"
items = []
FILE = open(file, 'r')
for line in FILE:
    metric = re.findall("(^\S*):", line)
    data = re.findall("(\S*)=\"(.*?)\"", line)
    if len(metric) != 0:
        entry = dict(data)
        item_entries = []
        item_entries.append(entry)
        items.append(item_entries)
    else:
        new_entry = dict(data)
        item_entries.append(new_entry)
FILE.close()

for item in items:
    html += "<tr>\n"
    counter = 0;
    for i in item:
        try:
            rows = i["rows"]
        except:
            rows = ""
        try:
            metric = i["metric"]
        except:
            metric = ""
        try:
            color = i["color"]
        except:
            color = ""
        try:
            url = i["url"]
        except:
            url = ""
        try:
            status = i["status"]
        except:
            status = ""

        if counter ==  0:
            html += "<td rowspan=\"%s\">%s</td>\n" % (rows, metric)
            if url:
                html += "<td bgcolor=\"%s\" align=\"center\"><a href=\"%s\">%s</a></td>" % (color, url, status)
            else:
                html += "<td bgcolor=\"%s\" align=\"center\">%s</td>" % (color, status)
        elif status:
                if url:
                    html += "<tr><td bgcolor=\"%s\" align=\"center\"><a href=\"%s\">%s%s</a></td></tr>" % (color, url, metric, status)
                else:
                    html += "<tr><td bgcolor=\"%s\" align=\"center\">%s%s</td></tr>" % (color, metric, status)
        counter += 1
    html += "</tr>\n"
html += "</tbody>\n"
html += "</table>\n"
html += "</p>\n"
html += "<p>\n"
timestamp = datetime.utcnow()
html += "Last Updated:  %s UTC\n" % (timestamp)
html += "</p>\n"
html += "</body>\n"
html += "</html>\n"

create_file(DATA_DIR + "qadashboard.html", html)
