#!/bin/bash
# This shell scripts runs the individual python scripts and publishes the
# qadashboard web page
# 
# Copyright 2010-2011  Canonical, Ltd.
# Author: Marjo Mercado <marjo.mercado@canonical.com>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See http://www.gnu.org/copyleft/gpl.html for
# the full text of the license.
#clear
#echo "This is information provided by run_report.sh. Program starts now."

DATA_DIR=~/qadashboard/data/
# Create the data directory if it doesn't exist
if [ ! -d $DATA_DIR ]
then
    mkdir -p $DATA_DIR
fi

python qadashboard_utils.py

#echo "Running bugs_most_users_affected"
python bugs_most_users_affected.py
#echo "Running bugs_most_duplicates"
python bugs_most_duplicates.py
#echo "Running regression_tracker"
python regression_tracker.py
#echo "Running boot_regressions"
python boot_regressions.py
#echo "Running dash-recent-bugs-packages"
python dash-recent-bugs-packages.py 1
python dash-recent-bugs-packages.py 7
#echo "Running hw_cert"
python hw_cert.py
#echo "Running iso_testing"
python iso_testing.py
#echo "Running automatic_upgrades"
python automatic_upgrades.py
#echo "Running mago_tests"
python mago_tests.py
#echo "Running server tests"
python server_tests.py
#echo "Running desktop tests"
python desktop_tests.py

# Data must be generated for the web page to change
#echo "Generating data"
python generate_data.py
#echo "Creating web page"
python qadashboard_html.py

#echo "Program is done!"
